<?php
/**
 * Juno base inclusion file. This file brings in all of the dependencies that
 * every Juno script will need and sets up objects that all scripts use.
 *
 * Copyright 1999-2005 Charles J. Hagenbuch <chuck@horde.org>
 * Copyright 1999-2005 Jon Parise <jon@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL). If you did not
 * receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * $Horde: juno/lib/base.php,v 1.39 2005/01/03 14:35:10 jan Exp $
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    @define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
$registry = &Registry::singleton();
if (is_a(($pushed = $registry->pushApp('juno', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
@define('JUNO_TEMPLATES', $registry->get('templates'));

/* Notification system. */
$notification = &Notification::singleton();
$notification->attach('status');

/* Find the base file path of Juno. */
@define('JUNO_BASE', dirname(__FILE__) . '/..');

/* Juno base libraries. */
require_once JUNO_BASE . '/lib/Juno.php';
require_once JUNO_BASE . '/lib/Books.php';
require_once JUNO_BASE . '/lib/Lists.php';

/* Horde libraries. */
require_once 'Horde/DataTree.php';

/* Help. */
require_once 'Horde/Help.php';

/* Juno drivers. */
/* Category driver for books. */
$GLOBALS['books'] = &new Juno_Books();

/* Set up the book object and status display. */
$GLOBALS['book'] = $GLOBALS['books']->getCurrentBook();
$GLOBALS['book_status'] = Juno::getBookStatus($GLOBALS['book']);

require_once JUNO_BASE . '/lib/Driver.php';
$GLOBALS['juno'] = &Juno_Driver::singleton();

/* Templates. */
require_once 'Horde/Template.php';
