<?php
/**
 * The Juno script to list the available accounts for the opened book.
 *
 * Copyright 2003-2005 Marko Djukic <marko@oblo.com>
 *
 * See the enclosed file COPYING for license information (GPL). If you did not
 * receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * $Horde: juno/lists/accounts.php,v 1.19 2005/01/03 14:35:10 jan Exp $
 *
 * @todo Clean up the accounts tree, add individual accounts actions (edit/del).
 */

@define('JUNO_BASE', dirname(__FILE__) . '/..');
require_once JUNO_BASE . '/lib/base.php';
require_once 'Horde/Tree.php';

/* Check if a book is open. */
Juno::isBookOpen();

$accounts = &Juno_Lists::singleton('accounts');

$accounts_list = $accounts->getList(DATATREE_ROOT, false, false, _("Accounts"));

/* Set up the tree. */
$accounts_tree = &Horde_Tree::factory('accounts_list', 'javascript');
$accounts_tree->setOption(array('width' => '100%', 'border' => '0', 'class' => 'item', 'alternate' => true, 'cellpadding' => '0', 'cellspacing' => '0'));

foreach ($accounts_list as $node_id => $node_val) {
    $parent_id = $accounts->getParentId($node_val);
    if ($node_id == DATATREE_ROOT) {
        $parent_id = null;
    }

    $accounts_tree->addNode($node_id, $parent_id, $node_val, substr_count($node_val, ':'));
}

$template = &new Horde_Template();
$template->set('menu', Juno::getMenu('string'));
$template->set('tabs', Juno::getTabs('lists'), true);

$url = Horde::applicationUrl('lists/editaccount.php');
$actions[] = array('url' => $url, 'label' => Horde::img('new_account.png', _("New account")));
$template->set('actions', $actions, true);
$template->set('accounts_tree', Util::bufferOutput(array($accounts_tree, 'renderTree')));
$template->set('notify', Util::bufferOutput(array($notification, 'notify')));

require JUNO_TEMPLATES . '/common-header.inc';
echo $template->fetch(JUNO_TEMPLATES . '/lists/accounts.html');
require $registry->get('templates', 'horde') . '/common-footer.inc';
