-- $Horde: juno/scripts/sql/juno.sql,v 1.2 2004/09/21 03:34:02 chuck Exp $

CREATE TABLE juno_transactions (
    transaction_id          INT NOT NULL DEFAULT 0,
    book_id                 INT NOT NULL DEFAULT 0,
    transaction_ref         VARCHAR(255) NOT NULL DEFAULT '',
    transaction_currency    VARCHAR(255) NOT NULL DEFAULT '',
    transaction_desc        TEXT NOT NULL,
    transaction_enterdate   INT NOT NULL DEFAULT 0,
    transaction_postdate    INT NOT NULL DEFAULT 0,
--
    PRIMARY KEY (transaction_id)
);

CREATE INDEX transaction_book_id_idx ON juno_transactions (book_id);
CREATE INDEX transaction_user_idx ON juno_transactions (user_uid);
CREATE INDEX transaction_ref_idx ON juno_transactions (transaction_ref);
CREATE INDEX transaction_enterdate_idx ON juno_transactions (transaction_enterdate);
CREATE INDEX transaction_postdate_idx ON juno_transactions (transaction_postdate);

CREATE TABLE juno_entries (
    entry_id                INT NOT NULL DEFAULT 0,
    transaction_id          INT NOT NULL DEFAULT 0,
    account_id              INT NOT NULL DEFAULT 0,
    entry_desc              TEXT NOT NULL,
    entry_amount            INT NOT NULL DEFAULT 0,
    book_amount             INT NOT NULL DEFAULT 0,
    entry_reconciledate     INT NOT NULL DEFAULT 0,
--
    PRIMARY KEY (entry_id)
);

CREATE INDEX entry_account_id_idx ON juno_entries (account_id);
CREATE INDEX entry_reconciledate_idx ON juno_entries (entry_reconciledate);

GRANT SELECT, INSERT, UPDATE, DELETE ON juno_transactions TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON juno_entries TO horde;

CREATE TABLE juno_transaction_attributes (
    transaction_id          VARCHAR(255) NOT NULL default '',
    attribute_name          VARCHAR(255) NOT NULL default '',
    attribute_key           VARCHAR(255) NOT NULL default '',
    attribute_value         TEXT
);

CREATE INDEX transaction_attributes_id_idx ON juno_transaction_attributes (transaction_id);
