<?php
/**
 * $Horde: juno/stocks/quote.php,v 1.33 2005/01/03 14:35:11 jan Exp $
 *
 * Copyright 2002-2005 Eric Rechlin <eric@hpcalc.org>
 *
 * Returns detailed information about the specified ticker symbol.
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/juno/LICENSE.
 */

@define('JUNO_BASE', dirname(__FILE__) . '/..');
require_once JUNO_BASE . '/lib/base.php';
require_once JUNO_BASE . '/lib/Stocks.php';

$ticker = Util::getFormData('ticker');
$title = $ticker ? sprintf(_("Latest Data for %s"), String::upper($ticker)) : _("My Portfolio");
require JUNO_TEMPLATES . '/common-header.inc';

if (!empty($ticker)) {
?>
<table cellspacing="0" width="100%"><tr><td class="header">
<?php echo String::upper($ticker) ?>
</td></tr><tr><td valign="top">
<?php

    $ticker = String::lower($ticker);
    $stocks = &Juno_Stocks::singleton('yahoo');
    $quote = $stocks->getQuotes($ticker);
    $quote = $quote[$ticker];

    echo '<table border="0" cellpadding="1" cellspacing="0" width="100%">';
    $i = 0;
    if (isset($quote['name'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Name") . '</td><td>';
        if (isset($quote['website'])) {
            echo Horde::link($quote['website'], $quote['name'], '', '_blank');
        }
        echo htmlentities($quote['name']);
        if (isset($quote['website'])) {
            echo '</a>';
        }
        echo '</td></tr>';
    }
    if (isset($quote['marketCenter'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Market Center") . '</td><td>' . htmlentities($quote['marketCenter']) . '</td></tr>';
    }
    if (isset($quote['lastPrice'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Last price") . '</td><td>' . $quote['lastPrice'] . '</td></tr>';
    }
    if (isset($quote['changePrice'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Change") . '</td><td>';
        if ($quote['changePrice'] > 0) {
            echo '<span style="color:green">';
        } elseif ($quote['changePrice'] < 0) {
            echo '<span style="color:red">';
        }
        echo $quote['changePrice'];
        if ($quote['changePrice'] != 0) {
            echo '</span>';
        }
        echo '</td></tr>';
    }
    if (isset($quote['changePct'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Change %") . '</td><td>';
        if ($quote['changePct'] > 0) {
            echo '<span style="color:green">';
        } elseif ($quote['changePct'] < 0) {
            echo '<span style="color:red">';
        }
        echo $quote['changePct'];
        if ($quote['changePct'] != 0) {
            echo '</font>';
        }
        echo '</td></tr>';
    }
    if (isset($quote['high'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Today's high") . '</td><td>' . $quote['high'] . '</td></tr>';
    }
    if (isset($quote['low'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Today's low") . '</td><td>' . $quote['low'] . '</td></tr>';
    }
    if (isset($quote['yearlyHigh'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("52-week high") . '</td><td>' . $quote['yearlyHigh'] . '</td></tr>';
    }
    if (isset($quote['yearlyLow'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("52-week low") . '</td><td>' . $quote['yearlyLow'] . '</td></tr>';
    }
    if (isset($quote['lastClose'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Previous close") . '</td><td>' . $quote['lastClose'] . '</td></tr>';
    }
    if (isset($quote['volume'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Volume") . '</td><td>' . number_format($quote['volume']) . '</td></tr>';
    }
    if (isset($quote['peRatio'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("P-E ratio") . '</td><td>' . $quote['peRatio'] . '</td></tr>';
    }
    if (isset($quote['yieldPct'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Yield %") . '</td><td>' . $quote['yieldPct'] . '</td></tr>';
    }
    if (isset($quote['earnings'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Earnings") . '</td><td>' . $quote['earnings'] . '</td></tr>';
    }
    if (isset($quote['dividentAmt'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Last dividend") . '</td><td>' . $quote['dividendAmt'] . '</td></tr>';
    }
    if (isset($quote['dividendDate'])) {
        if ($quote['dividendDate'] > 19700000) {
            echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
            echo _("Last dividend date") . '</td><td>' . $quote['dividendDate'] . '</td></tr>';
        }
    }
    if (isset($quote['sp500Beta'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("S&amp;P 500 beta") . '</td><td>' . $quote['sp500Beta'] . '</td></tr>';
    }
    if (isset($quote['tradeDate'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Quote date") . '</td><td>' . $quote['tradeDate'] . '</td></tr>';
    }
    if (isset($quote['marketCap'])) {
        echo '<tr class="item' . ($i++ % 2) . '"><td valign="top">';
        echo _("Market cap") . '</td><td>' . number_format($quote['marketCap']) . '</td></tr>';
    }

    echo '</td></tr></table>';
} else {
    $tickers = Juno_Stocks::getTickerSymbols();
    if (!count($tickers)) {
        $notification->push(_("You have no ticker symbols in your portfolio."));
    }

    $main = '<table border="0" width="100%" cellspacing="0" cellpadding="1"><tr><td class="header">' . _("My Portfolio") . '</td><td class="header" align="right"><span class="smallheader">' . Horde::link(Util::addParameter(Horde::url($GLOBALS['registry']->get('webroot', 'horde') . '/services/prefs.php?app=juno'), 'group', 'stocks'), _("Edit My Portfolio"), 'smallheader') . _("Edit My Portfolio") . '</a></span></td></tr></table>';
    if (count($tickers)) {
        $main .= Juno_Stocks::getStockListing($tickers);
    }

    $template = &new Horde_Template();
    $template->set('menu', Juno::getMenu('string'));
    $template->set('main', $main);
    $template->set('notify', Util::bufferOutput(array($notification, 'notify')));

    echo $template->fetch(JUNO_BASE . '/templates/main/main.html');
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
